// printView.cpp : implementation of the CPrintView class
//

#include "stdafx.h"
#include "print.h"

#include "printDoc.h"
#include "printView.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintView

IMPLEMENT_DYNCREATE(CPrintView, CView)

BEGIN_MESSAGE_MAP(CPrintView, CView)
	//{{AFX_MSG_MAP(CPrintView)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrintView construction/destruction

CPrintView::CPrintView()
{
}

CPrintView::~CPrintView()
{
}

BOOL CPrintView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPrintView drawing

void CPrintView::OnDraw(CDC* pDC)
{
	CPrintDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CBitmap bitMap;
	BITMAP mp;
	CRect rect;
	GetClientRect(&rect);
	bitMap.LoadBitmap(IDB_BITMAP1);
	bitMap.GetObject(sizeof(mp),&mp);
	CDC memDC;
	memDC.CreateCompatibleDC(pDC);
	memDC.SelectObject(&bitMap);
	//мͼƬ
	::TransparentBlt(pDC->m_hDC,(rect.right/2)-(mp.bmWidth/2),(rect.bottom/2)-(mp.bmHeight/2),mp.bmWidth,mp.bmHeight,memDC.m_hDC,0,0,mp.bmWidth,mp.bmHeight,RGB(0,0,0));
	ReleaseDC(&memDC);
	ReleaseDC(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CPrintView printing

BOOL CPrintView::OnPreparePrinting(CPrintInfo* pInfo)
{
	//ʹӡĬϺӡ
	LPDEVMODE   lpDevMode;
	PRINTDLG pd=pInfo->m_pPD->m_pd;
	if(AfxGetApp()->GetPrinterDeviceDefaults(&pd)){
		lpDevMode=(LPDEVMODE)GlobalLock(pd.hDevMode);
		if(lpDevMode){
			lpDevMode->dmPaperSize=DMPAPER_A4;
			lpDevMode->dmOrientation=DMORIENT_LANDSCAPE;//ӡ
		}
		GlobalUnlock(pd.hDevMode);
	}
	//ʹӡĬϺӡ
	return DoPreparePrinting(pInfo);
}

void CPrintView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CPrintView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CPrintView diagnostics

#ifdef _DEBUG
void CPrintView::AssertValid() const
{
	CView::AssertValid();
}

void CPrintView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPrintDoc* CPrintView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPrintDoc)));
	return (CPrintDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPrintView message handlers

void CPrintView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	//ôӡת
	pDC->SetMapMode(MM_ANISOTROPIC);
	int screenwidth_real=GetSystemMetrics(SM_CXSCREEN);
	int screenheight_real=GetSystemMetrics(SM_CYSCREEN);
	CSize winSize=CSize(screenwidth_real,screenheight_real);
	//ôڴС
	pDC->SetWindowExt(winSize);
	long xLogPixPerInch,yLogPixPerInch;
	//豸꼴ÿӢ
	xLogPixPerInch=pDC->GetDeviceCaps(LOGPIXELSX);
	yLogPixPerInch=pDC->GetDeviceCaps(LOGPIXELSY);
	//ӿڴС 96%
	pDC->SetViewportExt(xLogPixPerInch*winSize.cx/96,yLogPixPerInch*winSize.cy/96);
CView::OnPrepareDC(pDC, pInfo);
	CView::OnPrepareDC(pDC, pInfo);
}
